﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.31
@EndOfDesignText@
'v1.00
#Event: ShowAction(Index As Int)
#Event: ActionClicked(Index As Int, TextAction as String)
Sub Class_Globals
	Private xui As XUI
	Private clv2 As CustomListView
	Private PressedColor As Int
	Private Top As Int
	Private pnl As B4XView
	Private ListStartY As Int
	Private dWidth, dBackground, dTextColor As Int
	Private downX, downY As Int
	Private verticalMove, horizontalMove, leftMove As Boolean
	Private lvInitialSize As Int
	Private mCallback As Object
	Private mEventName As String
	
	Public Base As B4XView
	Private ActionsPanel As B4XView
	Private actions As List
	Private LastSwipedItem As Int = -1
End Sub

'Recibimos la vista y la lista de textos a mostrar en cada ítem:
Public Sub Initialize (clv As CustomListView, Callback As Object, EventName As String)
	clv2 = clv
	PressedColor = clv2.PressedColor
	dTextColor = clv2.DefaultTextColor
	dBackground = xui.Color_Transparent
	dWidth = 30dip
	mCallback = Callback
	mEventName = EventName
	
	actions = Array("Remove", "Edit")
	
	
	For i = 0 To clv2.Size -1
		
		ActionsPanel = xui.CreatePanel("")
		
		ActionsPanel.Tag = "ActionsPanel"
		
		Dim item As CLVItem = clv2.GetRawListItem(i)
		If ActionsPanel.Parent.IsInitialized Then ActionsPanel.RemoveViewFromParent
		item.Panel.Parent.AddView(ActionsPanel, 0, item.Panel.Top, item.Panel.Width, item.Panel.Height)
		ActionsPanel.SendToBack

		CreateActionButtons(i)
	Next	
End Sub

'Set values for dragger width, background color and text color
'or defaults will be used - width=30dip, background color=transparetn, text color=clv default color
Public Sub SetDefaults (width As Int, backColor As Int, txtColor As Int)
	dWidth = width
	dBackground = backColor
	dTextColor = txtColor
End Sub


Public Sub RemoveDragButtons
	For i = 0 To clv2.Size - 1
		Dim p As B4XView = clv2.GetPanel(i)
		Dim b As Boolean = IsLastViewADragLabel(p)
		If b Then	'IsLastViewADragLabel(p) Then
			p.GetView(p.NumberOfViews - 1).RemoveViewFromParent
		End If
	Next
	clv2.PressedColor = PressedColor
End Sub


Private Sub IsLastViewADragLabel (p As B4XView) As Boolean
	If p.NumberOfViews > 0 Then
		Dim v As B4XView = p.GetView(p.NumberOfViews - 1)
		If v Is Label And v.Tag = Null Then
			Return False
		End If
		Return v Is Label And v.Tag = clv2
	End If
	Return False
End Sub


Public Sub AddDragButtons
	clv2.PressedColor = xui.Color_Transparent
	Dim fnt As B4XFont = xui.CreateMaterialIcons(30)	'Get the font provided by the XUI Views library
	For i = 0 To clv2.Size - 1
		Dim p As B4XView = clv2.GetPanel(i)
		If IsLastViewADragLabel(p) = False Then
			Dim lbl As Label
			lbl.Initialize("")	'Drag")
			Dim xlbl As B4XView = lbl
			xlbl.Font = fnt
			xlbl.Text = Chr(0xE25D)
			xlbl.TextColor = dTextColor
			xlbl.Color = dBackground
			xlbl.SetTextAlignment("CENTER", "CENTER")
			
			'We put the CustomListView in the Label tag
			xlbl.Tag = clv2
			
			p.AddView(xlbl, p.Width - dWidth -10dip, p.Height / 2 - 15dip, dWidth, 30dip)
			
			'We activate a Listener for each Label
			Dim r As Reflector
			r.Target = lbl	
			r.SetOnTouchListener("lbl_Touch")
		End If
	Next
End Sub

Private Sub lbl_Touch(ViewTag As Object, Action As Int, X As Float, Y As Float, EventData As Object) As Boolean
	Dim lbl As B4XView = Sender
	Dim clv2 As CustomListView = lbl.Tag	'(¿Es necesario así?)
	
	'Now here for you to take the value on time:
	Dim index As Int = clv2.GetItemFromView(lbl)
	

	If Action = 0 Then				'ACTION_DOWN
		
		'We disable ScrollView when touch starts with:
		Dim r As Reflector
		r.Target = clv2.sv		
		r.RunMethod2("requestDisallowInterceptTouchEvent", True, "java.lang.boolean")
		
		'We access the item panel and paint a lilac border
		pnl = clv2.GetPanel(clv2.GetItemFromView(lbl)).Parent
		pnl.GetView(0).SetColorAndBorder(xui.Color_Transparent, 3dip, 0xFF503ACD, 0)	'= #503ACD
		ListStartY = Y + lbl.Top + pnl.Top
		pnl.BringToFront
		Top = pnl.Top
		
		downX = X
		downY = Y
		
		verticalMove = False
		horizontalMove = False
		leftMove = False
		
		lvInitialSize = clv2.Size
		
		
		
	Else If Action = 1 Then				'ACTION_UP
		
'		Dim index As Int = clv2.GetItemFromView(lbl)
		
'		'To control the reset of the position of the last moved item
		LastSwipedItem = index

'		'We put the element back to its initial border color and position when dragged to the right
		If horizontalMove = True And leftMove = False Then
			pnl.Left = 0
			pnl.GetView(0).SetColorAndBorder(pnl.Color, 0dip, xui.Color_Black, 0)
		End If
		
		
		If horizontalMove = True And leftMove = True Then

'			'We pass the removing and edit to the event with animation
			CallSub2(mCallback, mEventName & "_ShowAction", index)
		End If
		

		
		Log("leftMove on up = " & leftMove)
		
'		Log(clv2.Size)
		
		
		'If we have not removed the item. VerticalMove if we want to leave the item in that position until we decide (in the event)
		If lvInitialSize = clv2.Size And verticalMove = True And pnl.Left = 0 Then		'--> Added pnl.Left > 0 so it doesn't reposition the item when moving it vertically when actions are displayed
			
			'pnl.Left = 0 <- ActionsPanel is not showing now
			Log(pnl.Left)
			
			Dim index As Int = clv2.GetItemFromView(lbl)
			pnl = clv2.GetPanel(index).Parent
			
			'Find the index of the next item:
			Dim Offset As Int = pnl.Top + pnl.Height / 2					'(a + b) / 2
			Dim NewIndex As Int = clv2.FindIndexFromOffset(Offset)
		
			Log("Step 1, index = " & index & ", Offset = " & Offset & ", NewIndex = " & NewIndex)
		
		

			
			Dim UnderlyingItem As CLVItem = clv2.GetRawListItem(NewIndex)		'The next CLVItem
			If Offset - UnderlyingItem.Offset > UnderlyingItem.Size / 2 Then	'If half of the CLVItem that we move minus half of the Offset (midpoint) of the next CLVItem is greater than half of the next CLVItem
				NewIndex = NewIndex + 1
				Log("NewIndex after UnderlyingItem = " & NewIndex)
			End If
			
			Log("Offset: " & Offset & " UnderlyingItem.Offset " & UnderlyingItem.Offset & " Size / 2: " & (UnderlyingItem.Size / 2))
			
			Dim ActualItem As B4XView  = pnl.GetView(0)
			ActualItem.RemoveViewFromParent
			ActualItem.SetColorAndBorder(pnl.Color, 0dip, xui.Color_Black, 0)
			
			Dim RawItem As CLVItem = clv2.GetRawListItem(index)
			clv2.RemoveAt(index)
			If NewIndex > index Then
				NewIndex = NewIndex - 1
'			Log("NewIndex after RawItem = " & NewIndex)
			End If
			NewIndex = Max(0, Min(clv2.Size, NewIndex))
'			Log("NewIndex after Max = " & NewIndex)
		
			clv2.InsertAt(NewIndex, ActualItem, RawItem.Value)
			clv2.GetRawListItem(NewIndex).TextItem = RawItem.TextItem
		End If
			


	Else If Action = 2 Then 			'ACTION_MOVE
		
		'We only allow one type of movement:
		If verticalMove = False And Abs(X - downX) > Abs(Y - downY) Then
			horizontalMove = True
			SetVisibleActionsPanels(True)
			
		Else If horizontalMove = False And Abs(X - downX) < Abs(Y - downY) Then
			verticalMove = True

			If LastSwipedItem <> index Then
				Log("LastSwipedItem = " & LastSwipedItem & " and index = " & index)
				
				'We close the previously swiped item
				CloseLastSwiped
			End If

		End If
		
		If horizontalMove = True Then
			
			Log("X = " & X & " and downX = " & downX)
			
			If X < downX Then
					
				'In case you end up moving your finger to the right. For the record you first moved it to the left. Do not allow movement to the right
				leftMove = True


				'Allows you to return to the zero left position of the previous item swiped
				'Put here to match the same direction of the ShowAction event:
				CloseLastSwiped
				
			
			Else If X > downX Then
				
				leftMove = False
				
			End If
			
			Log("leftMove = " & leftMove)
			
			pnl.Left = pnl.Left + X - downX

			
		Else If verticalMove = True And pnl.Left = 0 Then		'We control the vertical movement
			
			SetVisibleActionsPanels(False)
			
			If clv2.Size < 2 Then Return True
			
			
			'To auto scroll:
			If pnl.Top < clv2.sv.ScrollViewOffsetY Then
				clv2.sv.ScrollViewOffsetY = Max(0, clv2.sv.ScrollViewOffsetY - 10dip)
			Else If clv2.sv.ScrollViewOffsetY + clv2.sv.Height < pnl.Top + pnl.Height Then
				clv2.sv.ScrollViewOffsetY = clv2.sv.ScrollViewOffsetY + 10dip
			End If
			
			'We allow movement:				
			Dim ListY As Int = Y + lbl.Top 	+ pnl.Top
			Dim delta As Int = ListY - ListStartY
			pnl.Top = Top + delta
		End If
		
	Else 
		
		Log("action " & Action)
	End If
	
	Return True
End Sub


Private Sub CreateActionButtons (Index As Int) 'As Int
	
	ActionsPanel.RemoveAllViews
	Dim LastX As Int = 0
	For Each action As String In actions
		Dim l As Label
		l.Initialize("lblAction")
		Dim xlbl As B4XView = l
		xlbl.Text = action
		xlbl.Tag = Index

		If xlbl.Text = "Remove" Then
			xlbl.Color = xui.Color_Red
		Else
			xlbl.Color = xui.Color_Blue
		End If

		xlbl.SetTextAlignment("CENTER", "CENTER")
		xlbl.Font = xui.CreateDefaultBoldFont(20)
		xlbl.TextColor = xui.Color_White

		Dim width As Int = 80dip
		ActionsPanel.AddView(xlbl, ActionsPanel.Width - width - LastX, 0, width, ActionsPanel.Height)
		LastX = LastX + width
	Next
End Sub


Public Sub RemoveActionsPanel
	
	ActionsPanel.RemoveViewFromParent

'	(The positions of the subsequent ActionsPanel are rearranged)
End Sub


Public Sub CreateActionsPanel(Index As Int)
	
	ActionsPanel = xui.CreatePanel("")	'Again for create the panel correctly
	Dim item As CLVItem = clv2.GetRawListItem(Index)
	If ActionsPanel.Parent.IsInitialized Then ActionsPanel.RemoveViewFromParent
	item.Panel.Parent.AddView(ActionsPanel, 0, item.Panel.Top, item.Panel.Width, item.Panel.Height)
	ActionsPanel.SendToBack
	
	CreateActionButtons(Index)
End Sub


Public Sub SetVisibleActionsPanels(Estate As Boolean)
	
	For i = 0 To clv2.Size - 1
		
		Dim item As CLVItem = clv2.GetRawListItem(i)
		Dim v As View = item.Panel.Parent.GetView(i)
'		Log(v.Tag)	'ActionsPanel
		v.Visible = Estate
	Next
End Sub


Public Sub CloseLastSwiped
	
	Log("CloseLastSwiped")
	
	'So that it does not fail when the device is rotated
	If LastSwipedItem = -1 Then Return
	
	Dim pnl2 As Panel = clv2.GetPanel(LastSwipedItem).Parent
	pnl2.Left = 0

	clv2.GetPanel(LastSwipedItem).SetColorAndBorder(pnl.Color, 0dip, xui.Color_Black, 0)
End Sub


Private Sub LblAction_Click
	
	Dim lbl1 As B4XView = Sender
	Log("lbl1.Tag = " & lbl1.Tag & " and lbl1.Text = " & lbl1.Text)

	CallSub3(mCallback, mEventName & "_ActionClicked", lbl1.Tag, lbl1.Text)
End Sub